<!DOCTYPE html>
<!-- Generated by pkgdown: do not edit by hand --><html lang="en"><head><meta http-equiv="Content-Type" content="text/html; charset=UTF-8"><meta charset="utf-8"><meta http-equiv="X-UA-Compatible" content="IE=edge"><meta name="viewport" content="width=device-width, initial-scale=1, shrink-to-fit=no"><title>TODOs • rdb.report</title><script src="lightswitch.js"></script><script src="deps/jquery-3.6.0/jquery-3.6.0.min.js"></script><meta name="viewport" content="width=device-width, initial-scale=1, shrink-to-fit=no"><link href="deps/bootstrap-5.3.1/bootstrap.min.css" rel="stylesheet"><script src="deps/bootstrap-5.3.1/bootstrap.bundle.min.js"></script><link href="deps/font-awesome-6.5.2/css/all.min.css" rel="stylesheet"><link href="deps/font-awesome-6.5.2/css/v4-shims.min.css" rel="stylesheet"><script src="deps/headroom-0.11.0/headroom.min.js"></script><script src="deps/headroom-0.11.0/jQuery.headroom.min.js"></script><script src="deps/bootstrap-toc-1.0.1/bootstrap-toc.min.js"></script><script src="deps/clipboard.js-2.0.11/clipboard.min.js"></script><script src="deps/search-1.0.0/autocomplete.jquery.min.js"></script><script src="deps/search-1.0.0/fuse.min.js"></script><script src="deps/search-1.0.0/mark.min.js"></script><!-- pkgdown --><script src="pkgdown.js"></script><meta property="og:title" content="TODOs"><meta name="twitter:card" content="summary"><meta name="twitter:creator" content="@2BSalim"><meta name="twitter:site" content="@2BSalim"><meta name="robots" content="noindex"><script src="https://rpkg.dev/counter-dev.min.js" data-id="4c4963fe-9fcf-4d81-95bb-2135e114b85b" data-utcoffset="1"></script></head><body>
    <a href="#main" class="visually-hidden-focusable">Skip to contents</a>


    <nav class="navbar navbar-expand-lg fixed-top " aria-label="Site navigation"><div class="container">

    <a class="navbar-brand me-2" href="index.html">rdb.report</a>

    <small class="nav-text text-danger me-auto" data-bs-toggle="tooltip" data-bs-placement="bottom" title="In-development version">0.0.9016</small>


    <button class="navbar-toggler" type="button" data-bs-toggle="collapse" data-bs-target="#navbar" aria-controls="navbar" aria-expanded="false" aria-label="Toggle navigation">
      <span class="navbar-toggler-icon"></span>
    </button>

    <div id="navbar" class="collapse navbar-collapse ms-3">
      <ul class="navbar-nav me-auto"><li class="nav-item"><a class="nav-link" href="articles/rdb-report.html">Get started</a></li>
<li class="nav-item"><a class="nav-link" href="reference/index.html">Reference</a></li>
      </ul><ul class="navbar-nav"><li class="nav-item"><form class="form-inline" role="search">
 <input class="form-control" type="search" name="search-input" id="search-input" autocomplete="off" aria-label="Search site" placeholder="Search for" data-search-index="search.json"></form></li>
<li class="nav-item"><a class="external-link nav-link" href="https://gitlab.com/zdaarau/rpkgs/rdb.report/" aria-label="GitLab"><span class="fa fab fa-gitlab fa-lg"></span></a></li>
<li class="nav-item dropdown">
  <button class="nav-link dropdown-toggle" type="button" id="dropdown-lightswitch" data-bs-toggle="dropdown" aria-expanded="false" aria-haspopup="true" aria-label="Light switch"><span class="fa fa-sun"></span></button>
  <ul class="dropdown-menu dropdown-menu-end" aria-labelledby="dropdown-lightswitch"><li><button class="dropdown-item" data-bs-theme-value="light"><span class="fa fa-sun"></span> Light</button></li>
    <li><button class="dropdown-item" data-bs-theme-value="dark"><span class="fa fa-moon"></span> Dark</button></li>
    <li><button class="dropdown-item" data-bs-theme-value="auto"><span class="fa fa-adjust"></span> Auto</button></li>
  </ul></li>
      </ul></div>


  </div>
</nav><div class="container template-title-body">
<div class="row">
  <main id="main" class="col-md-9"><div class="page-header">

      <h1>TODOs</h1>
      <small class="dont-index">Source: <a href="https://gitlab.com/zdaarau/rpkgs/rdb.report/blob/HEAD/TODO.md" class="external-link"><code>TODO.md</code></a></small>
    </div>

<div id="todos" class="section level1">

<hr><div class="section level2">
<h2 id="technical--programming">Technical / Programming<a class="anchor" aria-label="anchor" href="#technical--programming"></a></h2>
<ul><li><p>try out PDF generation via <a href="https://quarto.org/docs/output-formats/typst.html" class="external-link">Typst</a>; once support for Quarto’s article layout classes <a href="https://quarto.org/docs/output-formats/typst.html#known-limitations" class="external-link">is implemented</a>, Typst should hopefully prove way less frustating than LaTeX!</p></li>
<li><p>explain pre-assembly step (<code>rdb.report:preassemble()</code>) in the intro vignette</p></li>
<li><p>add some time-insensitive sentinel for plot generation and regenerate plots only if sentinel has changed</p></li>
<li><p>make all static versions of htmlwidgets (plotly charts etc.) link to interactive ones</p></li>
<li><p>add an <a href="https://r-pkgs.org/misc.html#sec-misc-inst-citation" class="external-link"><code>inst/CITATION</code></a> file to repo that defines how the report is to be cited; see <a href="https://github.com/plotly/plotly.R/blob/master/inst/CITATION" class="external-link">plotly’s</a> for an example</p></li>
<li><p>add fns to visualize moving averages; see the <a href="https://slider.r-lib.org/" class="external-link">slider</a> package for data prep</p></li>
<li><p>experiment with <em>bump charts</em> to visualize rankings over time using pkg <a href="https://github.com/davidsjoberg/ggbump" class="external-link">ggbump</a> and <em>sankey bump charts</em> to also visualize the underlying absolute values using pkg <a href="https://github.com/davidsjoberg/ggsankey#geom_sankey_bump" class="external-link">ggsankey</a></p></li>
<li><p>experiment with <a href="https://gt.rstudio.com/reference/opt_interactive.html" class="external-link">interactive gt tables</a> in HTML output; would be great if we could create all tbls with gt and avoid having to create separate <a href="https://rstudio.github.io/DT/" class="external-link">DT</a> tables for interactive output!</p></li>
<li>
<p>Visual polishing: Consider using</p>
<ul><li>
<a href="https://icons.getbootstrap.com/" class="external-link">Bootstrap Icons</a>. There’s a dedicated Quarto extension <a href="https://github.com/shafayetShafee/bsicons" class="external-link">available</a>. There’s also an R package <a href="https://github.com/rstudio/bsicons" class="external-link">bsicons</a> available.</li>
<li>CSS animations based on <a href="https://animate.style/" class="external-link">Animate.css</a>. There’s a dedicated Quarto extension <a href="https://github.com/mcanouil/quarto-animate" class="external-link">available</a>.</li>
</ul></li>
<li>
<p>Further tweak <a href="https://quarto.org/docs/journals/templates.html#template-partials" class="external-link">custom Pandoc LaTeX template</a> <code>input/report/assets/templates/template.latex</code></p>
<ul><li>using <code>\usepackage{footnotebackref}</code> to add backlinks to footnote references (same as for the <a href="https://github.com/Wandmalfarbe/pandoc-latex-template#custom-template-variables" class="external-link">Eisvogel Pandoc template</a> (<code>footnotes-disable-backlinks</code>)) has no effect -&gt; further investigate!</li>
</ul></li>
<li>
<p>add <a href="https://quarto.org/docs/extensions/lua.html" class="external-link">Pandoc Lua filter</a> that adds an <a href="https://pandoc.org/MANUAL.html#extension-auto_identifiers" class="external-link">autogenerated <code>id</code> attribute</a> to <code>&lt;dt&gt;</code> elements inside definition lists (<code>&lt;dl&gt;</code> elements).</p>
<p>proposed <a href="https://github.com/quarto-dev/quarto-cli/issues/1697#issuecomment-1462441697" class="external-link">upstream</a>… let’s wait for now.</p>
</li>
<li><p>implement pkgdown article ToC generation for headers &lt; h2, cf. <a href="https://github.com/r-lib/pkgdown/issues/1357#issuecomment-2450526911" class="external-link uri">https://github.com/r-lib/pkgdown/issues/1357#issuecomment-2450526911</a></p></li>
</ul><div class="section level3">
<h3 id="bug-reports--upstream-issues">Bug reports / upstream issues<a class="anchor" aria-label="anchor" href="#bug-reports--upstream-issues"></a></h3>
<ul><li>
<p>HTML figure output does not respect the <code>fig-column</code> chunk opt when <code>fig-subcap</code> is set, cf. <a href="https://github.com/quarto-dev/quarto-cli/issues/8763" class="external-link uri">https://github.com/quarto-dev/quarto-cli/issues/8763</a>. Note that setting <a href="https://quarto.org/docs/authoring/article-layout.html#code-cell-options" class="external-link"><code>column</code></a> instead of (or in addition to) <code>fig-column</code> has a visual effect, but results in subpar layout. Possible workaround is <a href="https://github.com/quarto-dev/quarto-cli/issues/8763#issuecomment-1951461094" class="external-link">very clunky</a>, so we’re just waiting for a proper upstream fix.</p>
<p>Note that also setting <code>layout-ncol: 1</code> results in broken layout (makes fig left-aligned instead of centered in page) -&gt; submit separate bug report?</p>
</li>
<li>
<p>report Quarto bugs:</p>
<ul><li><p>Setting <code>fig-column</code> (in contrast to <code>column</code>) on htmlwidget output has no effect anymore since Quarto 1.5 (or already 1.4? it worked in 1.3.450!)</p></li>
<li>
<p>submit bug report about not being able to use YAML expressions (<code>!expr 'ifelse(knitr::is_html_output(), "body", "page")'</code>) in chunk opts <code>tbl-column</code>/<code>fig-column</code>:</p>
<pre><code>ERROR: Validation of YAML cell metadata failed.
ERROR: Render failed due to invalid YAML.</code></pre>
<p>note that as a workaround, the option can be set on the upper chunk fence line via <code>```{r, tbl-column` = ifelse(knitr::is_html_output(), "body", "page")}</code>.</p>
<p>fixing this would allow us to set the <code>tbl-column: !expr 'ifelse(knitr::is_html_output(), "body", "page")'</code> option YAML-based for chunk <code>tbl-n-bd-per-wave-top-ten</code> in <code>overall/trend-analyis.qmd</code>.</p>
</li>
<li><p>when rendering profile <code>"html-minimal"</code>, the file <code>hypthesis.qmd</code> is wrongly left in the output dir (probably since we didn’t include it in <code>chapters</code> or <code>appendices</code>) -&gt; create minimal reprex!</p></li>
<li><p>layout bug in mobile view -&gt; hypothes.is toolbar overlaps search button!</p></li>
<li><p>an e-mail address formatted as inline code (<a href="mailto:some@one.com"><code>some@one.com</code></a>) is rendered to <code>&lt;code&gt;some@one.com&lt;/code&gt;</code>!</p></li>
<li><p>feature request for new config opt <code>tbl-pos</code> similar to the existing <code>fig-pos</code>!</p></li>
<li>
<p><a href="https://quarto.org/docs/output-formats/html-basics.html#external-links" class="external-link">external links</a>:</p>
<ul><li>skip for
<ul><li>
<code>mailto:</code> links</li>
<li>
<code>file:</code> links (relevant when viweing rendered HTML files directly from disk in browser, i.e. not served by a local web server)</li>
<li>
<code>&lt;a&gt;</code> elements that only contain icons (<code>&lt;i&gt;</code>)</li>
<li>links in the <code>page-footer</code>
</li>
</ul></li>
<li>document supported regex syntax for <code>link-external-filter</code>. word boundaries (<code>\b</code>) used to work (in Quarto v1.2) but now don’t (in v1.3).</li>
</ul></li>
<li><p>titles of figures which are not part of a <a href="https://quarto.org/docs/authoring/figures.html#figure-panels" class="external-link">figure panel</a> are formatted differently in HTML output because their <code>&lt;figcaption&gt;</code> element is <em>below</em> the main <code>&lt;figure&gt;</code> element, while for panel figures, <code>&lt;figcaption&gt;</code> element is <em>besides</em> the <code>&lt;figure&gt;</code> element. -&gt; create reprex! related: <a href="https://github.com/quarto-dev/quarto-cli/issues/1346" class="external-link uri">https://github.com/quarto-dev/quarto-cli/issues/1346</a></p></li>
<li><p>with <a href="https://quarto.org/docs/authoring/figures.html#caption-locations" class="external-link"><code>fig-cap-location: top</code></a> and 2-or-more column <a href="https://quarto.org/docs/authoring/figures.html#figure-panels" class="external-link">figure panels</a> and <em>long</em> (i.e. multiline) figure subtitles, the alignment of the resulting subfigures is subpar. Setting <code>\floatsetup[figure]{style=Plaintop, ...}</code> has no effect on this (cf. chapter 3.1.1 Float Style in <a href="http://mirrors.ctan.org/macros/latex/contrib/floatrow/floatrow.pdf" class="external-link">floatrow documentation</a>) -&gt; create minimal reprex and, if issue also occurs in vanilla Quarto layout without our floatrow setup, report it upstream!</p></li>
</ul></li>
<li><p>test if RStudio’s citation insertion feature properly respects CSL-JSON’s <code>citation-key</code> field (should take precedence over <code>id</code>), and if not, create reprex and <a href="https://github.com/rstudio/rstudio/issues" class="external-link">open issue</a>; cf. <a href="https://github.com/zotero/dataserver/issues/119" class="external-link uri">https://github.com/zotero/dataserver/issues/119</a></p></li>
<li>
<p>Quarto <a href="https://quarto.org/docs/authoring/cross-references.html#sections" class="external-link">section cross-references</a> to book <em>parts</em> don’t seem to work (while referencing chapters works). Submit feature request with minimal reprex.</p>
<p>Besides, section cross-references to book appendices don’t respect the config option <code>crossref.appendix-title</code> and just print “Chapter <math display="block" xmlns="http://www.w3.org/1998/Math/MathML"><semantics><mrow><mi>A</mi><mo>−</mo><mi>Z</mi></mrow><annotation encoding="application/x-tex">A-Z</annotation></semantics></math>”. Submit separate bug report.</p>
</li>
<li><p>Once <a href="https://github.com/quarto-dev/quarto-cli/issues/3157" class="external-link">quarto-dev/quarto-cli#3157</a> is fixed, set <code>engine: knitr</code> globally in <code>_quarto.yml</code>.</p></li>
</ul></div>
<div class="section level3">
<h3 id="report">Report<a class="anchor" aria-label="anchor" href="#report"></a></h3>
<ul><li>
<p>Add some “key indicators” using bslib’s <a href="https://rstudio.github.io/bslib/articles/value-boxes.html#expandable-sparklines" class="external-link">value boxes</a> (with expandable graphs)</p>
<ul><li>on report’s landing page (overall indicators).</li>
<li>per country; we could include various external info like scores on common <a href="https://de.wikipedia.org/wiki/Kroatien#Politische_Indizes" class="external-link">political indices</a>.</li>
</ul></li>
<li><p>Include copyright and license info in all SVG plots and hide its container element via CSS, so when plots are downloaded, the info is visible.</p></li>
<li>
<p>experiment with <a href="https://quarto.org/docs/output-formats/html-basics.html#tabsets" class="external-link">Quarto tabsets</a> and the <a href="https://github.com/quarto-ext/grouped-tabsets" class="external-link"><code>grouped-tabsets</code> extension</a>; we could e.g show a tab for</p>
<ul><li>analysis by referendum vs. ballot date</li>
<li>each subregion in a specific region</li>
<li>plot vs. table</li>
<li>etc.</li>
</ul></li>
<li><p>experiment with <a href="https://quarto.org/docs/projects/code-execution.html#cache" class="external-link">knitr caching</a>; the <a href="https://yihui.org/knitr/demo/cache/#even-more-stuff-for-cache" class="external-link"><code>cache.extra</code> chunk opt</a> might allow enough finetuning</p></li>
<li><p>restore <code>plot_bar_rfrnds_per_period()</code>?</p></li>
<li>
<p>choose (and tweak) a different CSL file which is really optimized for Quarto’s inline footnotes?</p>
<p>make sure to rely on <a href="https://docs.citationstyles.org/en/stable/primer.html#locale-files" class="external-link">CSL locale files</a>!</p>
<ul><li>
<p><a href="https://en.wikipedia.org/wiki/ISO_690" class="external-link">ISO 690</a>-based; though <a href="https://www.citavi.com/de/nuetzliche-irrtuemer/artikel/normgerecht-zitieren" class="external-link">this article</a> states the standard has flaws;</p>
<p>we’d base the CSL file on</p>
<ul><li>
<a href="https://github.com/citation-style-language/styles/blob/v1.0.2/iso690-full-note-with-ibid-ro.csl" class="external-link"><code>iso690-full-note-with-ibid-ro</code></a> as base</li>
<li>
<a href="https://github.com/citation-style-language/styles/blob/v1.0.2/iso690-numeric-lt.csl" class="external-link"><code>iso690-numeric-lt.csl</code></a> for superscript refs</li>
<li>
<a href="https://github.com/citation-style-language/styles/blob/v1.0.2/iso690-numeric-cs.csl" class="external-link"><code>iso690-numeric-cs.csl</code></a> for properly indented bib?</li>
</ul></li>
</ul></li>
<li>
<p>As main font, consider <a href="https://edwardtufte.github.io/et-book/" class="external-link">ET Book</a>, i.a. used by <a href="https://edwardtufte.github.io/tufte-css/" class="external-link">Tufte CSS</a>. Note that <a href="https://github.com/edwardtufte/et-book/pull/25" class="external-link">@dpk is currently overhauling the font</a> in a <a href="https://github.com/edwardtufte/et-book/pull/25" class="external-link">separate fork</a>, might be better to first await some stable release from her.</p>
<p>Since ET Book is not available on Google Fonts, we have to include it manually. We could generate the files using <code><a href="https://rstudio.github.io/sass/reference/font_face.html" class="external-link">sass::font_face()</a></code> in <code>report_update_fonts()</code>, something like:</p>
<div class="sourceCode" id="cb2"><pre class="downlit sourceCode r">
<code class="sourceCode R"><span><span class="fu">sass</span><span class="fu">::</span><span class="fu"><a href="https://rstudio.github.io/sass/reference/font_face.html" class="external-link">font_face</a></span><span class="op">(</span>family <span class="op">=</span> <span class="st">"etbook"</span>,</span>
<span>                src <span class="op">=</span> <span class="st">"url(/assets/font/ETBook/etbookot-roman-webfont.woff2) format('woff2')"</span>,</span>
<span>                style <span class="op">=</span> <span class="st">"normal"</span>,</span>
<span>                weight <span class="op">=</span> <span class="st">"400"</span>,</span>
<span>                display <span class="op">=</span> <span class="st">"swap"</span><span class="op">)</span></span></code></pre></div>
</li>
</ul></div>
<div class="section level3">
<h3 id="dashboard">Dashboard<a class="anchor" aria-label="anchor" href="#dashboard"></a></h3>
<ul><li>
<p>create dashboard (skeleton) to be deployed to <code>dashboard.rdb.vote</code></p>
<p>technical:</p>
<ul><li>R package <a href="https://rmarkdown.rstudio.com/flexdashboard/" class="external-link"><strong>flexdashboard</strong></a> seems promising, see also chapter <a href="https://bookdown.org/yihui/rmarkdown/dashboards.html#dashboards" class="external-link">Dashboards</a> in <em>R Markdown: The Definitive Guide</em>; the underlying Bootstrap theme can easily be customized via R package <a href="https://dreamrs.github.io/fresh/" class="external-link">fresh</a>
</li>
<li>
<a href="https://quarto.org/docs/dashboards/" class="external-link">Quarto dashboards</a> seem to be quite mature, maybe the more future-proof choice?</li>
</ul><p>Fill dashboard with plots which summarize the most relevant info at a glance; maybe limit this to <em>overall</em> status-like info? or create two separate (or more) dashboards?</p>
</li>
</ul><hr></div>
</div>
<div class="section level2">
<h2 id="content">Content<a class="anchor" aria-label="anchor" href="#content"></a></h2>
<div class="section level3">
<h3 id="fundamentals">Fundamentals<a class="anchor" aria-label="anchor" href="#fundamentals"></a></h3>
<ul><li>
<p>Grundsätzlich:</p>
<ul><li>Land-für-Land (vorerst nur auf nationaler Basis); siehe auch <a href="https://en.wikipedia.org/wiki/Referendums_by_country" class="external-link"><em>Referendums by country</em> on Wikipedia</a>
</li>
<li>Aggregiert nach Weltregionen (“Weltbank-Regionen” o.ä.)</li>
<li>Top-Ten (oder wieviel auch immer) je 5 Jahre, à la Heatmaps</li>
<li>Appendix mit Vorlagen nach Land und einigen ausgewählten</li>
</ul></li>
<li><p>Immer enthalten: Auflistung aller Abstimmungen pro Land im aktuellen Jahr mit vielen schönen Zusatzangaben aus den Datenbank-Variablen; Länder nach Kontinenten bzw. Weltregionen strukturieren</p></li>
</ul></div>
<div class="section level3">
<h3 id="brainstorming">Brainstorming<a class="anchor" aria-label="anchor" href="#brainstorming"></a></h3>
<ul><li>
<p>Anhang</p>
<ul><li>Changelog für den Report</li>
</ul></li>
</ul></div>
<div class="section level3">
<h3 id="inspirations">Inspirations<a class="anchor" aria-label="anchor" href="#inspirations"></a></h3>
<ul><li><p>see Google Drive folder <a href="https://drive.google.com/drive/folders/1Z6IsBspB4LmHR-Q4TnzDaKONRymweOZo" class="external-link"><code>RDB/Annual Report/Inspirations/</code></a></p></li>
<li><p><a href="https://www.defacto.expert/2020/03/30/wahlteilnahme/" class="external-link">participation</a></p></li>
</ul><hr></div>
</div>
<div class="section level2">
<h2 id="outreach">Outreach<a class="anchor" aria-label="anchor" href="#outreach"></a></h2>
<ul><li><p><a href="https://ius.unibas.ch/de/personen/nadja-braun-binder/jahrbuch-fuer-direkte-demokratie/" class="external-link">Jahrbuch für direkte Demokratie</a></p></li>
<li><p><a href="https://en.wikipedia.org/wiki/V-Dem_Institute" class="external-link">V-Dem Democracy Index</a> (Altman stützt sich für einen Direkte-Demokratie-Unter-Index auf die RDB ohne die Quelle sauber zu zitieren…)</p></li>
</ul></div>
</div>

  </main><aside class="col-md-3"><nav id="toc" aria-label="Table of contents"><h2>On this page</h2>
    </nav></aside></div>


    <footer><div class="pkgdown-footer-left">
  <p>Developed by Salim Brüggemann, Uwe Serdült.</p>
</div>

<div class="pkgdown-footer-right">
  <p>Site built with <a href="https://pkgdown.r-lib.org/" class="external-link">pkgdown</a> 2.1.1.9000.</p>
</div>

    </footer></div>





  </body></html>

